package com.supervision.ai.service.hub.controller;

import com.supervision.ai.service.hub.dto.common.R;
import com.supervision.ai.service.hub.service.ComfyUIService;
import com.supervision.ai.service.hub.vo.comfyui.RunPromptReqVo;
import com.supervision.ai.service.hub.vo.comfyui.TaskResultResVo;
import jakarta.servlet.http.HttpServletResponse;
import lombok.RequiredArgsConstructor;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import java.util.List;

@RestController
@RequestMapping("/comfyui")
@RequiredArgsConstructor
public class ComfyUIController {

    private final ComfyUIService comfyUIService;

    /**
     * 运行prompt
     * @param runPromptReqVo prompt信息
     * @return
     */
    @PostMapping("/run")
    public R<String> runPrompt(@RequestBody RunPromptReqVo runPromptReqVo) {

        String taskId = comfyUIService.runPrompt(runPromptReqVo);
        return R.ok(taskId);
    }

    @GetMapping("/queryHistory")
    public R<List<TaskResultResVo>> queryHistory(@RequestParam(name = "promptId", required = false) String promptId) {
        List<TaskResultResVo> taskResultResVos = comfyUIService.queryHistory(promptId);
        return R.ok(taskResultResVos);
    }

    @PostMapping("/uploadImage")
    public R<String> uploadImage(@RequestParam("file") MultipartFile file) throws Exception {
        String imageId = comfyUIService.uploadImage(file);
        return R.ok(imageId);
    }

    @GetMapping("/downloadView")
    public void downloadView(@RequestParam("fileName") String fileName, HttpServletResponse response) throws Exception {
        comfyUIService.downloadView(fileName, response);
    }
}
